#!/usr/bin/python3

import requests
import json

from binance.client import Client
from binance.websockets import BinanceSocketManager

session = requests.session()

pairs = {
    "BTCUSDT":"BTCUSDT",
    "ETHUSDT":"ETHUSDT",
    "BCHUSDT":"BCHUSDT"
}

client = Client("11", "22", {"verify":False, "timeout":20})

bm = BinanceSocketManager(client)

def process_message(msg):
    amount = float(msg["q"])
    if not msg['m']:
        amount = -amount

    trade = {
        'amount':amount,
        'price':float(msg["p"]),
        'symbol':msg["s"]
    }
    symbol = msg['s']
    jsondict = {
        'market':pairs[symbol],
        'type':'trade',
        'data':trade 
    }
    myPusher(jsondict)

# ----
def myPusher(jsondict):
    print (jsondict)
    ret = session.post("http://dna1.viewdao.com:5000/post/ticker", data=json.dumps(jsondict))
    print (ret.content)

if __name__ == '__main__':
    for key in pairs.keys():
        conn_key = bm.start_trade_socket(key, process_message)
    bm.start()
