#!/usr/bin/python3

import requests
import json
import asyncio

from huobi import subscribe

session = requests.session()

pairs = {
#    "market.repusdt.trade.detail":"REPUSDT",
    "market.sntusdt.trade.detail":"SNTUSDT",
    "market.zrxusdt.trade.detail":"ZRXUSDT",
    "market.qtumusdt.trade.detail":"QTUMUSDT",
    "market.linkusdt.trade.detail":"LINKUSDT",
    "market.batusdt.trade.detail":"BATUSDT"
}

async def callback(data):
    #print(data)
    msg = data['tick']['data'][0]
    amount = msg["amount"]
    if msg['direction'] == 'sell':
        amount = -amount
    trade = {
        'amount':amount,
        'price':msg["price"]
    }
    symbol = data['ch']
    jsondict = {
        'market':pairs[symbol],
        'type':'trade',
        'usdt':True,
        'data':trade 
    }
    cost = msg["amount"] * msg["price"]
    if  cost > 15 and cost < 800:
        myPusher(jsondict)

# ----
def myPusher(jsondict):
    #print (jsondict)
    try:
        ret = session.post("http://34.225.58.115:9090/post/ticker", data=json.dumps(jsondict))
        print (ret.content)
    except Exception as e:
        print (str(e))

if __name__ == '__main__':
    builder = {}
    for key in pairs.keys():
        builder[key] = {'callback':callback}
    print (builder)
    tasks = subscribe(builder)
    asyncio.get_event_loop().run_until_complete(tasks)
