#!/usr/bin/python3

import requests
import json
from bfxapi import Client

#######################
bfx = Client(logLevel='INFO')

session = requests.session()

pairs = {
    "tBTCUSD":"BTCUSDT",
    "tETHUSD":"ETHUSDT",
#    "tEOSUSD":"EOSUSDT",
    "tLTCUSD":"LTCUSDT",
    "tDSHUSD":"DASHUSDT",
    "tXMRUSD":"XMRUSDT",
    "tBSVUSD":"BSVUSDT",
    "tOMGUSD":"OMGUSDT",
    "tUSTUSD":"USDT"
}

#######################
@bfx.ws.on('error')
def log_error(err):
  print ("Error: {}".format(err))

@bfx.ws.on('new_candle')
def log_candle(candle):
  print ("New candle: {}".format(candle))

@bfx.ws.on('ticker')
def log_ticker(ticker):
  print ("New ticker: {}".format(ticker))

@bfx.ws.on('new_trade')
def log_trade(trade):
  #print ("New trade: {}".format(trade))
  symbol = trade["symbol"]
  jsondict = {'market':pairs[symbol],
    'type':'trade',
    'data':trade}
  myPusher(jsondict)

# ----
def myPusher(jsondict):
  print (jsondict)
  ret = session.post("http://34.225.58.115:9090/post/ticker", data=json.dumps(jsondict))
  print (ret.content)

def setPrice(asset, price):
  jsondict = {'asset':asset,'price':price}
  ret = session.post("http://34.225.58.115:9090/set/price", data=json.dumps(jsondict))
  print (ret.content)

async def start():
  usdtTicker = await bfx.rest.get_public_ticker('tUSTUSD')
  setPrice('USDT', usdtTicker[6])
  for key in pairs.keys():
    await bfx.ws.subscribe('trades', key)

#######################
if __name__ == '__main__':
  bfx.ws.on('connected', start)
  bfx.ws.run()
